# strongswan

This module allows to manage strongswan on Debian via swanctl / VICI, route-based or otherwise.

## Table of Contents

1. [Setup](#setup)
1. [Usage](#usage)
1. [Limitations](#limitations)
1. [Development](#development)

## Setup

Besides installing the module, no special setup steps are necessary.

## Usage

`strongswan` supplies parameters which are directly mapped to the according blocks in `strongswan.conf` and `swanctl.conf`.
Therefore, it is recommended to use it via `include` and put the config into hiera. The keys are named as in strongswan,
except that `-` is replaced by `_`. Hashes are mapped to blocks. Key/value pairs are mapped to `key = value` with the exception
of `include` as key. In this case, the `=` is omitted.

### Special Values

There are a few values which are not passed through to the config files:
* `strongswan::route_based`: If set to true, XFRM interfaces are added for each interface ID occuring in the config.
* `strongswan::connections/<connection>/base_interface` sets the base interface for an XFRM device.
* `strongswan::connections/<connection>/if_id` is copied into `if_id_in` and `if_id_out`.

### Example

```
strongswan::charon:
  load_modular: yes
    plugins:
        include: strongswan.d/charon/*.conf
```
yields this `strongswan.conf`
```
charon {
    load_modular = true
    plugins {
        include strongswan.d/charon/*.conf
    }
}
```

## Limitations

This module was only tested on Debian and uses `/etc/network/interfaces` (i.e. no `networkd` etc.) for route based VPNs.

## Development

The repo is located at https://software.service.zit-rlp.de/puppet/strongswan.
