Puppet::Functions.create_function(:'strongswan::hash_to_strongswan_config') do
  dispatch :hash_to_strongswan_config do
    param 'Hash', :data
  end

  def hash_to_strongswan_config(data, key: nil, value: nil, indent: 0)
    if key.nil? || value.nil?
      return data.map { |k, v| (v.nil? || v.empty?) ? '' : hash_to_strongswan_config(nil, key: k, value: v) }.join('')
    end
    s = ''
    indent.times { s += "\t" }
    if value.is_a?(Hash)
      "#{s}#{key} {\n" + \
        value.map { |k, v| hash_to_strongswan_config(nil, key: k, value: v, indent: indent + 1) }.join('') + \
        s + "}\n"
    elsif key == 'include'
      value = [value] unless value.is_a?(Array)
      value.map { |x| "#{s}#{key} #{x}\n" }.join
    else
      "#{s}#{key} = #{value}\n"
    end
  end
end
