# @summary Create interface file for xfrm device.
#
# @param base_interface Interface used as PHYS_DEV for xfrm interface.
# @param routes Array of networks which are routed onto the xfrm interface.
# @param interface_id IF_ID of the interface (required to match IPSec policy).
define strongswan::xfrm (
  String $base_interface,
  Array $routes,
  Integer $interface_id
) {
  file { "/etc/network/interfaces.d/${name}":
    owner   => 'root',
    mode    => '0644',
    content => template('strongswan/xfrm.erb'),
    notify  => Exec["set_${name}_up"],
  }
  ->exec { "set_${name}_up":
    command     => "/usr/sbin/ifup ${name}",
    refreshonly => true,
  }
}
